import pandas as pd
import regr_simple as original
import regr_preprocessed as proc


def generate_data_sets():

    # Load the data
    data = pd.read_csv('Aroma_Database.csv', sep=';', header=0)
    data_clean = data.dropna()

    for temperature in [4.0, 7.0, 30.0, 37.0, 40.0]:
        filtered_data = data_clean[data_clean['Temperature'] == temperature]
        file_name = "FilteredData_" + str(temperature) + ".csv"
        filtered_data.drop(columns=['Temperature']).to_csv(file_name, sep=';', index=False)


preprocessing = False
generate_data = True

if generate_data:
    generate_data_sets()

# Available temperatures:
# 40.0    199
# 30.0    101
# 37.0     64
# 7.0      27
# 4.0      20
# 25.0     17
# 8.0      12
# 60.0      8
# 70.0      8
# 80.0      8
# 20.0      6
# 10.0      2
# 13.0      2


for temp in [4.0, 7.0, 30.0, 37.0, 40.0]:

    file = "FilteredData_" + str(temp) + ".csv"

    if preprocessing:
        proc.train_lin_regression(file, temp)
        proc.train_random_forest_regression(file, temp)
        proc.train_gb_regression(file, temp)
        proc.train_xgb_regression(file, temp)
        proc.train_svr(file, temp)
        proc.train_nn(file, temp)
    else:
        original.train_lin_regression(file, temp)
        original.train_random_forest_regression(file, temp)
        original.train_gb_regression(file, temp)
        original.train_xgb_regression(file, temp)
        original.train_svr(file, temp)
        original.train_nn(file, temp)
